# selenium.webdriver.common.service

Classes

`Service`([executable_path, port, log_output, env]) | The abstract base class for all service objects.

class selenium.webdriver.common.service.Service(executable_path: str = None, port: int = 0, log_output: int | str | IO[Any] = None, env: Mapping[Any, Any] | None = None, **kwargs)

  The abstract base class for all service objects. Services typically launch a child program in a new process as an interim process to communicate with a browser.

  Parameters:

    - executable – install path of the executable.

    - port – Port for the service to run on, defaults to 0 where the operating system will decide.

    - log_output – (Optional) int representation of STDOUT/DEVNULL, any IO instance or String path to file.

    - env – (Optional) Mapping of environment variables for the new process, defaults to os.environ.

  property service_url: str

    Gets the url of the Service.

  abstract command_line_args() → List[str]

    A List of program arguments (excluding the executable).

  property path: str
  start() → None

    Starts the Service.

    Exceptions:

      - WebDriverException : Raised either when it can’t start the service or when it can’t connect to the service

  assert_process_still_running() → None

    Check if the underlying process is still running.

  is_connectable() → bool

    Establishes a socket connection to determine if the service running on the port is accessible.

  send_remote_shutdown_command() → None

    Dispatch an HTTP request to the shutdown endpoint for the service in an attempt to stop it.

  stop() → None

    Stops the service.